package com.example.switchyard.switchyard_example;

import org.jboss.msc.service.Service;
import org.jboss.msc.service.StartContext;
import org.jboss.msc.service.StartException;
import org.jboss.msc.service.StopContext;
import org.jboss.msc.value.Value;
import org.jgroups.Channel;
import org.jgroups.JChannel;
import org.jgroups.blocks.locking.LockService;

public class DistributedLockService implements Service<LockService> {

    private final Value<Channel> channel;
    private final String cluster;
    private volatile LockService service;

    public DistributedLockService(Value<Channel> channel, String cluster) {
        this.channel = channel;
        this.cluster = cluster;
    }

    @Override
    public LockService getValue() {
        return service;
    }

    @Override
    public void start(StartContext context) throws StartException {
        JChannel jchannel = (JChannel) channel.getValue();
        service = new LockService(jchannel);
        try {
            jchannel.connect(cluster);
        } catch (Exception e) {
            throw new StartException(e);
        }
    }

    @Override
    public void stop(StopContext context) {
        channel.getValue().close();
        service = null;
    }
}

